#!python
# Copyright (c) 2000-2001 ActiveState Corporation.
# See the file LICENSE.txt for licensing information.

import types
from xpcom import components, _xpcom
import logging
import indexer, os, threading
log = logging.getLogger('koIndexer')

class koDocumentationSearchService:
    _com_interfaces_ = [components.interfaces.koIDocumentationSearchService]
    _reg_clsid_ = "{335414C5-7920-4273-B96D-7FC9665E01BD}"
    _reg_contractid_ = "@activestate.com/koDocumentationSearchService;1"
    _reg_desc_ = "Komodo Documentation Search Service"
    
    def __init__(self):
        self._index = index = indexer.ZPickleIndexer()
        dirs = components.classes['@activestate.com/koDirs;1'].getService()
        self.dbpath = dirs.mozBinDir + '/chrome/jaguar/content/doc/index.db'
        if not os.path.exists(self.dbpath+'!'):
            log.error("Index file %r doesn't exist", self.dbpath+'!')
        else:
            self._index.load_index(self.dbpath)
        
    def find(self, words):
        # _index.find() returns a dictionary:
        #   { <linenum> : <filename>\t<title>,
        #     <linenum> : <filename>\t<title>, 
        #     ... }
        # iff there are hits. If there are no hits the return value is '0'.
        # (Any empty dictionary would have been nice.)
        log.debug("looking for %r", words)
        hits = self._index.find(words.split())
        log.debug("found %r", hits)
        if type(hits) == types.DictType:
            # need to filter out the hits corresponding to the webservices
            # "template.html" file
            # XXX need to move the template.html out of the doc area to clean
            # this hack.
            for k,v in hits.items():
                if v.endswith('%%%TITLE%%%'):
                    del hits[k]
            print hits.values()
            return '\n'.join(hits.values())
        else:
            return ''

